%function plotH=plotProbDensity(pD,proj,axLimit,isoProb,colors);
%2D plot of probability density for projected array of GaussMixD objects
%Input:
%pD=        a single GaussMixD object or multidim array of GaussMixD objects
%proj=      vector with indices of vector elements to plot. *****NOT USED!!!
%           length(proj)==2 (but 3 should maybe also be allowed
%axLimit=   [xmin xmax ymin ymax] for plot generation
%isoProb=   relative probability density values for iso-probability curves
%colors=    string with plot color codes, 'rgb' etc
%
%Result:
%plotH=    vector with plot handles to graph objects
%
%Arne Leijon 2007-01-17 tested, not finished

function plotH=plotProbDensity(pD,proj,axLimit,isoProb,colors)
nPoints=100;%in each dimension
if length(proj)~=2
    error('Can only plot 2-D');end;%should be generalized!!!
if nargin<4
    isoProb=[];end;
if nargin<5 || isempty(colors)
    colors='rbgk';end;
dy=(axLimit(4)-axLimit(3))/nPoints;
dx=(axLimit(2)-axLimit(1))/nPoints;
x=(axLimit(1):dx:axLimit(2));
y=(axLimit(3):dy:axLimit(4));
[X,Y]=meshgrid(x,y);%size(X)==size(Y)
%xy=[repmat(x',[1,1,nPoints]);repmat(y,[1,nPoints,1])];%coord grid
xy=cat(1,reshape(X,[1,size(X)]),reshape(Y,[1,size(Y)]));%coord grid
xy=reshape(xy,2,size(xy,2)*size(xy,3));%coord grid as sequence of vectors

nObj=numel(pD);
plotH=[];%storage for plot handles
for i=1:nObj
    pdf=prob(pD(i),xy);%disregard single log scale factor
    pdf=reshape(pdf,size(X));%=size(Y)
    plotH=[plotH,pcolor(x,y,-pdf)];
    shading interp;
    colormap gray;
    caxis(caxis);%lock color map
    cObj=colors(1+mod(i-1,length(colors)));%circulate among given colors
    hold on;
    [C,h]=contour(x,y,log(pdf),log(isoProb),cObj);
    plotH=[plotH,h];
end;
hold off;
