%function r=stateEntropyRate(hmm);
%calculates mean state entropy rate/transition
%for a HMM object or multidim array of HMM objects
%
%Input:
%hmm=     single HMM object or multidim array of HMM objects
%
%Result:
%r=     matrix with state entropy rates (bits/sample)
%       size(r)==size(hmm)
%
%Arne Leijon 2009-07-23

function r=stateEntropyRate(hmm)
nObj=numel(hmm);
for i=1:nObj%for all of them
    r(i)=stateEntropyRate(hmm(i).StateGen);%just dispatch to sub-object
end;
r=reshape(r,size(hmm));
