% Gustav Eje Henter 2012-11-16

function [X,S,history] = rand(h,nSamples,history)

if (numel(h) > 1),
    error('Method works only for a single object');
end

if (nargin < 3),
    history = [];
end

S = rand(h.StateGen,nSamples);
nX = length(S);

D = h.DataSize;
X = zeros(D,nX);
tstart = 1;
while tstart <= nX,
    s = S(tstart);
    
    for tend = tstart+1:nX,
        if (S(tend) ~= s),
            tend = tend-1;
            break;
        end
    end
    if isempty(tend),
        tend = tstart;
    end
    
    [X(:,tstart:tend),history] = rand(h.OutputDistr(s),tend-tstart+1,history);
    tstart = tend+1;
end