% Gustav Eje Henter 2013-02-15

function xs = conditionalRand(k,nSamples,givenDims)

if (nargin < 2) || isempty(nSamples),
    nSamples = 1;
end

D = k.DataSize;

if (nargin < 3) || isempty(givenDims),
    givenDims = false(D,1); % Assume the unconditional case
end

if ~islogical(givenDims),
    givenDims = ismember((1:D)',givenDims);
else
    givenDims = reshape(givenDims,[],1);
end

Drand = sum(~givenDims);
if (Drand == 0),
    return;
end

taus = k.Taus(k.Tied);
taus = taus(~givenDims); % Prune irrelevant dimensions

xs = randn(Drand,nSamples).*repmat(1./sqrt(taus),1,nSamples);