% Gustav Eje Henter 2013-04-13

function k = init(k,xs,ws)

[D,N] = size(xs);

if (nargin < 3) || isempty(ws),
    ws = ones(1,N);
else
    ws = max(ws,0);
end

W = sum(ws);
if (abs(W - 1) <= N*eps), % Already normalized
    % Guess the effective number of points
    % based on the maximum element before normalization being one.
    W = 1/max(ws);
end
ws = ws/sum(ws);

M = xs*ws';
residuals = xs - repmat(M,1,N);

protoV = (residuals.^2)*ws';

if numel(k.Tied) ~= D,
    k.Tied = ones(D,1); % Isotropic kernel by default
    %k.Tied = (1:D)'; % No dimensional tying by default
end

% Apply the normal reference rule for bandwidth selection
% (Scott 1992; Bowman and Azzalini 1997)

%exponent = 2*k.binRatio/(D+k.binRatio); % Old rule
exponent = 2/(D+4); % New rule

k.Taus = zeros(max(k.Tied),1);
for i = 1:numel(k.Taus),
    %k.Taus(i) = (W.^exponent)./mean(protoV(k.Tied == i)); % Old rule
    k.Taus(i) = (((D+2)*W/4).^exponent)./mean(protoV(k.Tied == i)); % New rule
end