% Gustav Eje Henter 2012-11-02

function xs = conditionalRand(k,nSamples,givenDims,taus)

if (nargin < 2) || isempty(nSamples),
    nSamples = 1;
end

D = k.DataSize;

if (nargin < 3) || isempty(givenDims),
    givenDims = false(D,1); % Assume the unconditional case
end

if ~islogical(givenDims),
    givenDims = ismember((1:D)',givenDims);
else
    givenDims = reshape(givenDims,[],1);
end

Drand = sum(~givenDims);
if (Drand == 0),
    return;
end

if (nargin < 4) || isempty(taus),
    taus = k.Taus(~givenDims);
else
    if (size(taus,1) == 1)
        taus = repmat(taus,Drand,1);
    elseif (size(taus,1) == D)
        taus = taus(~givenDims,:); % Prune irrelevant dimensions
    end
end

if (size(taus,2) == 1),
    xs = randn(Drand,nSamples).*repmat(1./sqrt(taus),1,nSamples);
else
    xs = randn(Drand,nSamples)./sqrt(taus(:,1:nSamples));
end