% Gustav Eje Henter 2013-02-07

function k = init(k,xs,ws)

[D,N] = size(xs);

if (nargin < 3) || isempty(ws),
    ws = ones(1,N);
else
    ws = max(ws,0);
end

W = sum(ws);
ws = ws/W;

M = xs*ws';
residuals = xs - repmat(M,1,N);

protoV = (residuals.^2)*ws';

exponent = 2*k.binRatio/(D+k.binRatio);

if k.Isotropic,
    k.Taus = (N.^exponent)./mean(protoV).*ones(D,1);
else
    k.Taus = (N.^exponent)./protoV;
end