% Gustav Eje Henter 2012-11-02

function [lpzs,logS] = logprob(k,x1,x2,taus)

D = size(x1,1);

if (nargin < 4) || isempty(taus),
    taus = k.Taus;
else
    taus = taus.*ones(D,size(taus,2));
end

if (nargin < 3) || isempty(x2),
    x2 = x1;
end

if (size(taus,2) == 1),
    % One single tau-vector
    tmat = spdiags(taus,0,D,D);
    d2s = sqdistance(x1,x2,tmat);
    
    lpzs = (sum(log(taus)) - D*log(2*pi) - d2s)/2;
else
    error('Not implemented!');
    %d2s = sqdistance(x1,x2,tmat);
end

if (nargout > 1),
    logS = max(lpzs,[],1);
    lpzs = lpzs - repmat(logS,size(lpzs,1),1);
end