% Gustav Eje Henter 2013-05-04

classdef KDEHMM < HMM
    methods (Access=public)
        function h = KDEHMM(varargin)
            h = h@HMM(varargin{:}); % Use superclass constructor
        end
        %------------------------   Signatures of separately defined methods:
        function [h,logprobs] = train(h,xs,lxs,minIter,minStep)
            if (nargin < 2) || isempty(xs),
                [h.OutputDistr(:).Crossval] = deal(true);
                if ~h.OutputDistr(1).Stationary,
                    xs = [h.OutputDistr(1).Points(1:end,1)'...
                        h.OutputDistr(1).Points(end,2:end)];
                else
                    xs = h.OutputDistr(1).Points(1,1:end);
                end
                lxs = size(xs,2);
            elseif (nargin < 3) || isempty(lxs),
                lxs = size(xs,2);
            end
            if (nargin < 4) || isempty(minIter),
                minIter = 10;
            end
            if (nargin < 5) || isempty(minStep),
                minStep = realmax;
            end
            [h.OutputDistr(:).UpdateWeights]...
                = deal(h.OutputDistr(1).UpdateWeights);
            
            [h,logprobs] = train@HMM(h,xs,lxs,minIter,minStep);
            
            % Do not cross-validate by default
            [h.OutputDistr(:).Crossval] = deal(false);
        end
        [X,S] = rand(h,nSamples);
        [X,S] = conditionalRand(h,x0,nSamples,s0prob);
    end
end