% Gustav Eje Henter 2013-05-04

function mm = init(mm,x0s,ws)

o = mm.Order;
Dx = size(x0s,1);

if o <= 0,
    mm.Stationary = true; % IID is always stationary
end

mm.DSize = Dx;

pts = mm.series2points(x0s,mm.Stationary);
mm.Points = pts;

if (nargin < 3) || isempty(ws),
    ws = ones(1,size(pts,2));
else
    ws = max(ws,0);
end

if mm.Stationary,
    mm.Kern.Tied = repmat((1:Dx)',o+1,1);
else
    mm.Kern.Tied = (1:Dx*(o+1))';
end

mm.Kern = mm.Kern.init(pts,ws);

ws = ws/sum(ws);
mm.Weights = ws;