% Gustav Eje Henter 2013-02-04

function [p,logS,rhos] = conditionalProb(mm,xs,x0)

if (nargin < 2) || isempty(xs),
    xs = []; % Use self-logprob with cross-validation
end

if (nargin < 3),
    x0 = []; % Assume the unconditional case
end

nD = numel(mm);

[lp,lrhos] = conditionalLogprob(mm,xs,x0);

[p,logS] = propscalesplit(lp,1);

if (nargout < 2),
    p = p.*repmat(exp(logS),nD,1);
end

if (nargout < 3),
    return;
end

rhos = KernelDensity.expCell(lrhos);