% Gustav Eje Henter 2013-02-07

function [xs,zs] = conditionalRand(mm,x0,nSamples)

if (numel(mm) ~= 1),
    error('This function only works for a single object!');
end

if (nargin < 3) || isempty(nSamples),
    nSamples = 1;
end

if (nargin < 2) || isempty(x0),
    [xs,zs] = rand(mm,nSamples); % Assume the unconditional case
    return;
end

o = mm.Order;
N0 = size(x0,2);
Dx = mm.DSize;

if (o > N0),
    error('Initialization from partial context not implemented.');
end

zs = zeros(1,nSamples);
xs = zeros(Dx,N0+nSamples);

xs(:,1:N0) = x0;

givenDims = [true(o*Dx,1);false(Dx,1)];
context = [reshape(xs(:,N0-o+1:N0),[],1);zeros(Dx,1)];

for t = 1:nSamples,
    [context,zs(t)] = conditionalRand@KernelDensity(mm,...
        [context(Dx+1:end);zeros(Dx,1)],givenDims);
    xs(:,t+N0) = context(end-Dx+1:end);
end