% Gustav Eje Henter 2013-02-06

function pts = series2points(mm,xs,periodicExtension)

if (nargin < 2) || isempty(xs),
    pts = [];
    return;
end

if (nargin < 3),
    periodicExtension = false;
end

[Dx Nx] = size(xs);
o = mm.Order;
Dp = Dx*(o+1);

if (Dx ~= mm.DSize),
    error('Incompatible data size!');
end

if periodicExtension,
    pts = zeros(Dp,Nx);
    for l = 0:o,
        pts(Dx*l+1:Dx*(l+1),:) = [xs(:,l+1:end) xs(:,1:l)];
    end
else
    pts = zeros(Dp,Nx-o);
    for l = 0:o,
        pts(Dx*l+1:Dx*(l+1),:) = xs(:,l+1:end-o+l);
    end
end