% Gustav Eje Henter 2013-02-16

function [lp,lrhos] = logprob(mm,xs)

if (nargin < 2) || isempty(xs),
    xs = []; % Use self-logprob with cross-validation
    Nx = mm(1).NumPoints; % We assume all mm have the same number of points
else
    Nx = size(xs,2);
    Nx = Nx - mm(1).Order;
end

nD = numel(mm);

lp = zeros(nD,Nx);
lrhos = cell(nD,1);

for i = 1:nD,
    [lp(i,:),lrhos{i}] = singleLogprob(mm(i),xs);
end

if (nD == 1) && iscell(lrhos),
    lrhos = lrhos{1};
end