% Gustav Eje Henter 2013-01-31

function [p,logS,rhos] = prob(pD,xs)

if (nargin < 2) || isempty(xs),
    xs = []; % Use self-logprob with cross-validation
end

nD = numel(pD);

[lp,lrhos] = logprob(pD,xs);

[p,logS] = propscalesplit(lp,1);

if (nargout < 2),
    p = p.*repmat(exp(logS),nD,1);
end

if (nargout < 3),
    return;
end

rhos = KernelDensity.expCell(lrhos);