% Gustav Eje Henter 2012-11-03

function mm = init(mm,x0s,ws)

if (nargin < 3) || isempty(ws),
    ws = ones(1,size(x0s,2));
else
    ws = max(ws,0);
end

mm.Weights = ws/sum(ws);

o = mm.Order;
Nx = size(x0s,2);

if mm.Stationary,
    xs = zeros(o+1,Nx);
    for p = 1:o+1,
        xs(p,:) = [x0s(p:end) x0s(1:p-1)];
    end
    
    mm.Kern.Isotropic = true;
    mm.Kern = mm.Kern.init(xs,ws);
else
    error('Not implemented!');
end

mm.Points = xs;