% Gustav Eje Henter 2012-11-28

function [xs,zs] = rand(mm,nSamples,bwparms)

if (numel(mm) ~= 1),
    error('This function only works for a single object!');
end

if (nargin < 2) || isempty(nSamples),
    nSamples = 1;
end

if (nargin < 3),
    bwparms = [];
end

o = mm.Order;

if (o <= 0),
    [xs,zs] = rand@KernelDensity(mm,nSamples,bwparms);
    return;
end

zs = zeros(1,max(nSamples-o,1));
xs = zeros(1,nSamples);

[xs(1:o+1),zs(1)] = rand@KernelDensity(mm,1,bwparms);

if (nSamples < o+1),
    xs = xs(1:nSamples);
elseif (nSamples > o+1)
    [xs,zs(2:end)]...
        = conditionalRand(mm,xs(2:o+1),nSamples-o-1,bwparms);
end