% Gustav Eje Henter 2013-03-18

function [lp,lrhos] = singleConditionalLogprob(mm,xs,x0)

o = mm.Order;
Dm = mm.DSize;
Np = mm.NumPoints;

crossval = mm.Crossval || (nargin < 2) || isempty(xs);
if crossval,
    % Use self-log-prob with cross-validation, regardless of x0
    pts = [];
else
    %Dx = size(xs,1);
    %if (Dx ~= Dm),
    %    error('Incompatible data size!');
    %end
    
    if (nargin < 3),
        x0 = [];
    end
    N0 = size(x0,2);
    
    if (N0 < o),
        lp = []; % Not enough data to compute a non-cross validation value
        lrhos = zeros(Np,0);
        return;
    end
    
    % Convert to sequence of column vectors, only including relevant context
    pts = mm.series2points([x0(:,end-o+1:end) xs]);
end

givenDims = 1:(Dm*o);
[lp,lrhos] = singleConditionalLogprob@KernelDensity(mm,pts,givenDims);

if crossval && mm.Stationary,
    % Remove values due to periodic extension
    lp = lp(1:end-o);
    lrhos = lrhos(:,1:end-o);
end