% Gustav Eje Henter 2013-01-31

function [p,logS,rhos] = marginalProb(pD,xs,givenDims)

if (nargin < 2) || isempty(xs),
    xs = []; % Use self-logprob with cross-validation
end

if (nargin < 3),
    givenDims = []; % Assume the unconditional case
end

nD = numel(pD);

[lp,lrhos] = marginalLogprob(pD,xs,givenDims);

[p,logS] = propscalesplit(lp,1);

if (nargout < 2),
    p = p.*repmat(exp(logS),nD,1);
end

if (nargout < 3),
    return;
end

rhos = KernelDensity.expCell(lrhos);