% Gustav Eje Henter 2013-02-01

function [xs,zs] = rand(pD,nSamples)

if (numel(pD) ~= 1),
    error('This function only works for a single object!');
end

if (nargin < 2) || isempty(nSamples),
    nSamples = 1;
end

cmf = cumsum(pD.Weights);
cmf = cmf/cmf(end); % Renormalize just to be sure

zs = zeros(1,nSamples);
for t = 1:nSamples,
    zs(t) = find(rand < cmf,1,'first');
end

xs = pD.Points(:,zs);

xs = xs + pD.Kern.rand(nSamples);