% Gustav Eje Henter 2012-11-15

function logP = logprob(pD,x)

nD = numel(pD);
N = size(x,2);
o = pD.Order;

logP = zeros(nD,N-o);

for i = 1:nD,
    residual = residualForLogprob(pD(i),x);
    logP(i,:) = logprob@GaussD(pD(i),residual);
end;

function residual = residualForLogprob(pD,x)

[D N] = size(x);
o = pD.Order;

if (o <= 0),
    residual = x;
    return;
end

summMat = pD.getSummMat;

preds = -repmat(sum(pD.ARCoeff.*pD.SummMean,2),1,N-o);
for l = 1:o,
    c2 = conv2(x,fliplr(summMat(:,l)'),'full');
    preds = preds + spdiags(pD.ARCoeff(:,l),0,D,D)*c2(:,o:N-1);
end

residual = x(:,o+1:end) - preds; % Residual driving noise, including mean