% Gustav Eje Henter 2013-01-31

function [lp,lrhos] = singleConditionalLogprob(pD,xs,givenDims)

crossval = false;
if isempty(xs),
    crossval = true;
end

N = pD.NumPoints;

lpzsjoint = pD.Kern.logprob(pD.Points,xs);
lpzsmarg = pD.Kern.marginalLogprob(pD.Points,xs,givenDims);

[lpzsjoint,lpzsmarg] = pD.addLogWeights(crossval,lpzsjoint,lpzsmarg);

lsejoint = logsumexp(lpzsjoint,1);
lsemarg = logsumexp(lpzsmarg,1);

lp = lsejoint - lsemarg;

lrhos = lpzsjoint - repmat(lsejoint,N,1);