% Gustav Eje Henter 2012-11-12

function [p,rhos,logS] = marginalProb(pD,xs,givenDims,bwparms)

if (nargin < 4),
    bwparms = [];
end

N = pD.NumPoints;

crossval = false;
if (nargin < 2),
    xs = []; % Compute self-log-prob later
    crossval = true;
end

if (nargin < 3) || isempty(givenDims),
    %givenDims = false(pD.DataSize,1); % Assume the unconditional case
    Nx = size(xs,2);
    p = ones(1,Nx);
    logS = zeros(1,Nx);
    rhos = repmat(pD.Weights,1,Nx);
    return;
end

[lpzs,logS] = pD.Kern.marginalLogprob(pD.Points,xs,givenDims,bwparms);

% Incorporate component weights

%lpzs = lpzs + repmat(log(pD.Weights'),1,Nx);

Nx = size(lpzs,2);

wm = repmat(pD.Weights',1,Nx);
if crossval,
    wm = wm./repmat(1 - wm(1:N+1:N*N),N,1);
    wm(1:N+1:N*N) = 0;
end

lpzs = lpzs + log(wm);

% Recompute logS
logS2 = max(lpzs,[],1);
lpzs = lpzs - repmat(logS2,N,1);
logS = logS + logS2;

if (nargout > 1),
    rhos = exp(lpzs);
    rhos = rhos./repmat(sum(rhos,1),N,1);
end

if (nargout > 2),
    p = sum(exp(lpzs),1);
else
    p = sum(exp(lpzs),1).*exp(logS);
end