% Gustav Eje Henter 2012-11-28

function [p,logS,rhos] = prob(pD,xs,bwparms)

if (nargin < 3),
    bwparms = [];
end

if (nargin < 2) || isempty(xs),
    xs = []; % Use self-log-prob with cross-validation
end

nD = numel(pD);

%[p,logSall] = deal(zeros(nD,Nx));
%logS = zeros(1,Nx);
rhos = cell(nD,1);

for i = 1:nD,
    if (size(bwparms,2) == nD),
        bwparm = bwparms(:,i); % Different bandwidths for each model
    else
        bwparm = bwparms;
    end
    
    [prow,logSrow,rhos{i}] = singleProb(pD(i),xs,bwparm);
    
    if ~exist('logSall','var'),
        Nx = size(prow,2); % We assume all pD give the same number of p-values
        [p,logSall] = deal(zeros(nD,Nx));
    end
    p(i,:) = prow;
    logSall(i,:) = logSrow;
end

if (nD == 1),
    if iscell(rhos),
        rhos = rhos{1};
    end
    logS = logSall;
else
    % Recompute logS such that the largest p-element in each column is one
    logS = max(log(p) + logSall,[],1);
    p = p.*exp(logSall - repmat(logS,nD,1));
end

if (nargout < 2),
    p = p.*repmat(exp(logS),nD,1);
end