% Gustav Eje Henter 2013-05-29

function [maxxs,maxys] = estimate_maxima(ys,searchnear,tol)

if (nargin < 3) || ~isempty(tol),
    tol = 0.5;
end

ny = numel(ys);

yspline = fake_nat_spline(1:ny,ys);

maxxs = splineMaximaMinima(yspline)';

if (nargin > 1) && ~isempty(searchnear),
    crossdist = sqdistance(searchnear,maxxs);
    mindist = min(crossdist,[],1);
    filter = (mindist <= tol.*tol);
    
    maxxs = maxxs(filter);
end

maxys = ppval(yspline,maxxs);