% Gustav Eje Henter 2013-05-04

function rhos = gmm_rhos(gmd,pts,Dx)

if (nargin < 3) || isempty(Dx),
    Dx = 0;
end

ng = numel(gmd.Gaussians);
pX = gmd.Gaussians.prob(pts);

% Pad the beginning with partial rhos
if (Dx > 0),
    order = (size(pts,1)/Dx)-1;
    pX = [zeros(ng,order) pX];
    shortgmd = gmd;
    for o = 1:order,
        for i = 1:ng,
            shortgmd.Gaussians(i)...
                = GaussD('Mean',gmd.Gaussians(i).Mean(1:Dx*o),...
                'Covariance',gmd.Gaussians(i).Covariance(1:Dx*o,1:Dx*o));
        end
        pX(:,o) = shortgmd.Gaussians.prob(pts(1:Dx*o,1));
    end
end

rhos = pX.*repmat(reshape(gmd.MixWeight,[],1),1,size(pX,2));
rhos = rhos./repmat(sum(rhos,1),size(rhos,1),1);