% Gustav Eje Henter 2013-05-29

function gammas = phase2gamma(thetas,nstates)

nns = numel(nstates);

gammas = cell(1,nns);

for n = 1:nns,
    gammas{n} = phase2gamma_single(thetas,nstates(n));
end

if (nns == 1),
    gammas = gammas{1};
end

function gamma = phase2gamma_single(thetas,nstates)

nt = numel(thetas);

if (nstates == 1),
    gamma = ones(1,nt);
    return;
else
    gamma = zeros(nstates,nt);
end

statenums = nstates*mod(thetas/2/pi,1);

for t = 1:nt,
    lindex = floor(statenums(t))+1;
    rindex = mod(ceil(statenums(t)),nstates)+1;
    if (lindex == rindex),
        gamma(lindex,t) = 1;
    else
        gamma(lindex,t) = ceil(statenums(t)) - statenums(t);
        gamma(rindex,t) = statenums(t) - floor(statenums(t));
    end
end