% Gustav Eje Henter 2013-05-29

function gammas = qtile2gamma(qtiles,nstates)

nns = numel(nstates);

gammas = cell(1,nns);

for n = 1:nns,
    gammas{n} = qtile2gamma_single(qtiles,nstates(n));
end

if (nns == 1),
    gammas = gammas{1};
end

function gamma = qtile2gamma_single(qtiles,nstates)

nt = numel(qtiles);

if (nstates == 1),
    gamma = ones(1,nt);
    return;
else
    gamma = zeros(nstates,nt);
end

statenums = (nstates-1)*qtiles;

for t = 1:nt,
    lindex = floor(statenums(t))+1;
    rindex = ceil(statenums(t))+1;
    if (lindex == rindex),
        gamma(lindex,t) = 1;
    else
        gamma(lindex,t) = ceil(statenums(t)) - statenums(t);
        gamma(rindex,t) = statenums(t) - floor(statenums(t));
    end
end