% Gustav Eje Henter 2012-05-11

function add_required_paths(curr_path,recurse_num)

if (nargin < 1) || isempty(curr_path),
    curr_path = pwd;
end

if (nargin < 2) || isempty(recurse_num),
    recurse_num = 0;
end

if ~exist(curr_path,'file'),
    error(['Path or file "' curr_path '" does not exist!']);
end

if exist(curr_path,'dir'),
    if ~strcmp(curr_path(end),filesep),
        curr_path = [curr_path filesep];
    end
    
    addpath(curr_path);
    
    if (recurse_num ~= 0),
        dir_conts = dir(curr_path);
        for d = 3:numel(dir_conts), % Skip . and ..
            if dir_conts(d).isdir,
                add_required_paths([curr_path dir_conts(d).name filesep],...
                    recurse_num-1);
            end
        end
    end
    
    curr_path = [curr_path 'required_paths.mat'];
    if ~exist(curr_path,'file'),
        return;
    end
end

load(curr_path);

if ~exist('required_paths','var'),
    error(['File "' curr_path '" does not contain a required_paths variable!']);
end
if ~exist('recurse_paths','var'),
    if (recurse_num ~= 0),
        recurse_paths = (recurse_num-1)*ones(size(required_paths));
    else
        recurse_paths = zeros(size(required_paths));
    end
end

for d = 1:numel(required_paths),
    add_required_paths(required_paths{d},recurse_paths(d));
end