function r = laprnd(b)
%LAPRND Random arrays from Laplace distribution.
%   R = LAPRND(B) returns an array of independent random numbers chosen
%   from the Laplace distribution with scale parameter B and mean zero. The
%   size of R is the size of B.
%
%   Written by Gustav Eje Henter 2011-05-18. No error checking performed.
%   Exectute TYPE EXPRND to see an example of how to integrate proper error
%   checking.

r = sign(rand(size(b)) - 0.5).*exprnd(b);